//+++======================================================================+++
//+++                  TRIANGLE MTF TT x3 [Alex Green]                     +++
//+++======================================================================+++
#property copyright "  16  may  2016,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks-f41/" 

#property description "  ,    '' ''.     -      ,     -    .     ,    ."
#property description ": 2012 - *cmillion* [Vladimir Hlystov],  6.03.-15.05.16 - **,  3.05.16 - *Tankk*,  15.05.16 - *Alex Green*. 16.05.16 -    ."
//#property version   "3.00"

#property indicator_chart_window

enum calc { Triangle, Rectangle, Rhombus };

//+++======================================================================+++
//+++======================================================================+++

extern calc                  Show  =  Triangle;
extern int        BrokerTimeShift  =  0;
extern ENUM_TIMEFRAMES  TimeFrame  =  PERIOD_H4;
extern int              AnglePips  =  10;
extern color                Color  =  SlateBlue;
extern int           FiguresCount  =  6;

//+++======================================================================+++
//+++======================================================================+++
int init() 
{
   return(0);
}
//+++======================================================================+++
//+++======================================================================+++
int deinit() 
{
   ObjectsDeleteAll(0,OBJ_TRIANGLE);
   ObjectsDeleteAll(0,OBJ_RECTANGLE);
   return(0);
}
//+++======================================================================+++
//+++                  TRIANGLE MTF TT x3 [Alex Green]                     +++
//+++======================================================================+++
int start() 
{
   int i;
   double Angle=AnglePips*Point;    if (Digits==3 || Digits==5) Angle=AnglePips*10*Point; 
   
   //" " ==    "LondonTIME"    " "  .      "TimeFrame"
   //      -   .   . ,   (24) ==  4-  .... 
   // -    ???
   
   //http://forexsystemsru.com/yazyk-programmirovaniya-mql4/77111-dorabotka-botov-sovetnikov-indikatorov-vol-2-a-393.html  
   //  ,  - ...     ,    .
   //P.S.  .            . 
   
   for (i=0; i<FiguresCount; i++) 
   {
      int y=0;
      while (iTime(NULL,Period(),y)>(iTime(NULL,TimeFrame,i)+BrokerTimeShift*3600)) y++;
      
      if (Show==Triangle)
      {
      DrawTRIANGLE (Show+"_"+TimeFrame+"_"+BrokerTimeShift+"_"+i, 
      iTime(NULL,TimeFrame,i)+BrokerTimeShift*3600, iOpen(NULL,Period(),y), 
      iTime(NULL,TimeFrame,i)+TimeFrame*60+BrokerTimeShift*3600, iOpen(NULL,Period(),y)+Angle, 
      iTime(NULL,TimeFrame,i)+TimeFrame*60+BrokerTimeShift*3600, iOpen(NULL,Period(),y)-Angle, Color);
      }
      
      if (Show==Rectangle)
      {
      DrawRECTANGLE (Show+"_"+TimeFrame+"_"+BrokerTimeShift+"_"+i, 
      iTime(NULL,TimeFrame,i)+BrokerTimeShift*3600, iOpen(NULL,Period(),y)+Angle, 
      iTime(NULL,TimeFrame,i)+TimeFrame*60+BrokerTimeShift*3600, iOpen(NULL,Period(),y)-Angle, Color);
      }
      
      if (Show==Rhombus)
      {
      DrawRHOMBUS (Show+"_"+TimeFrame+"_"+BrokerTimeShift+"_"+i, 
      iTime(NULL,TimeFrame,i)+BrokerTimeShift*3600, iOpen(NULL,Period(),y), 
      iTime(NULL,TimeFrame,i)+(TimeFrame*60+BrokerTimeShift*3600)/2, iOpen(NULL,Period(),y)+Angle, 
      iTime(NULL,TimeFrame,i)+(TimeFrame*60+BrokerTimeShift*3600)/2, iOpen(NULL,Period(),y)-Angle,
      iTime(NULL,TimeFrame,i)+BrokerTimeShift*3600+TimeFrame*60, Color);
      }
   }
//----
   return(0);
}
//+++======================================================================+++
//+++                  TRIANGLE MTF TT x3 [Alex Green]                     +++
//+++======================================================================+++
void DrawTRIANGLE(string Name, datetime T3, double P3, datetime T2, double P2, datetime T1, double P1,  color C) 
{
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_TRIANGLE, 0, T3,P3,T2,P2,T1,P1);
   ObjectSet   (Name, OBJPROP_COLOR, C);
   ObjectSet   (Name, OBJPROP_BACK, true);
}
//+++======================================================================+++
//+++======================================================================+++
void DrawRECTANGLE(string Name, datetime T2, double P2, datetime T1, double P1,  color C) 
{
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_RECTANGLE, 0, T2,P2,T1,P1);
   ObjectSet   (Name, OBJPROP_STYLE, 0);
   ObjectSet   (Name, OBJPROP_COLOR, C);
   ObjectSet   (Name, OBJPROP_BACK, true);
}
//+++======================================================================+++
//+++======================================================================+++
void DrawRHOMBUS(string Name, datetime T3, double P3, datetime T2, double P2, datetime T1, double P1, datetime T4, color C) 
{
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_TRIANGLE, 0, T3,P3,T2,P2,T1,P1);
   ObjectSet   (Name, OBJPROP_COLOR, C);
   ObjectSet   (Name, OBJPROP_BACK, true);
   
   ObjectDelete(Name+1);
   ObjectCreate(Name+1, OBJ_TRIANGLE, 0, T4,P3,T2,P2,T1,P1);
   ObjectSet   (Name+1, OBJPROP_COLOR, C);
   ObjectSet   (Name+1, OBJPROP_BACK, true);
}
//+++======================================================================+++
//+++                  TRIANGLE MTF TT x3 [Alex Green]                     +++
//+++======================================================================+++